
int keydown(int basic_keycode)
{
    /* test*/
    const unsigned short* keyboard_register = (unsigned short*)0xA44B0000;
    int row, col, word, bit;
    row = basic_keycode%10;
    col = basic_keycode/10-1;
    word = row>>1;
    bit = col + 8*(row&1);
    return (0 != (keyboard_register[word] & 1<<bit));
}


void alphaSprite(int x, int y, int width, int height, short* bitmap, short alpha)
{
    short* VRAM = (short*)0xA8000000;
    int x_inc = width;
    if (y < 0)
    {
        bitmap -= y * width;
        height += y;
        y = 0;
    }
    if (height > LCD_HEIGHT_PX - y) height = LCD_HEIGHT_PX - y;

    if (x < 0)
    {
        bitmap -= x;
        width += x;
        x = 0;
    }
    if (width > LCD_WIDTH_PX - x) width = LCD_WIDTH_PX - x;

    x_inc -= width;

    int y_index;
    int x_index;
    short * base = y * LCD_WIDTH_PX + x + VRAM;
    for (y_index = height; y_index > 0; y_index--, base += LCD_WIDTH_PX - width, bitmap += x_inc)
    {
        for (x_index = width; x_index > 0; x_index--, base++ , bitmap++ )
        {
            if (*bitmap != alpha) *base = *bitmap;
        }
    }
}

int abs(int x)
{
    if (x<0)
        return (-x);
    else
        return (x);
}

//draws a point of color color at (x0, y0)
void plot(int x0, int y0, int color) {
   char* VRAM = (char*)0xA8000000;
   VRAM += 2*(y0*LCD_WIDTH_PX + x0);
   *(VRAM++) = (color&0x0000FF00)>>8;
   *(VRAM++) = (color&0x000000FF);
   return;
}

//Uses the Bresenham line algorithm
void drawLine(int x1, int y1, int x2, int y2, int color) {
    signed char ix;
    signed char iy;

    // if x1 == x2 or y1 == y2, then it does not matter what we set here
    int delta_x = (x2 > x1?(ix = 1, x2 - x1):(ix = -1, x1 - x2)) << 1;
    int delta_y = (y2 > y1?(iy = 1, y2 - y1):(iy = -1, y1 - y2)) << 1;

   plot(x1, y1, color);
    if (delta_x >= delta_y) {
        int error = delta_y - (delta_x >> 1);        // error may go below zero
        while (x1 != x2) {
            if (error >= 0) {
                if (error || (ix > 0)) {
                    y1 += iy;
                    error -= delta_x;
                }                           // else do nothing
         }                              // else do nothing
            x1 += ix;
            error += delta_y;
            plot(x1, y1, color);
        }
    } else {
        int error = delta_x - (delta_y >> 1);      // error may go below zero
        while (y1 != y2) {
            if (error >= 0) {
                if (error || (iy > 0)) {
                    x1 += ix;
                    error -= delta_y;
                }                           // else do nothing
            }                              // else do nothing
            y1 += iy;
            error += delta_x;
            plot(x1, y1, color);
        }
    }
}

void Rectangle(int x1, int y1 , int x2, int y2,int color)
{
    for (int i = x1;i<=x2;i++)
        drawLine(i,y1,i,y2,color);
}

int text_center_coord_x(char*str)
{
    int i = 1;
    while(str[i-1]!='\0'){i++;}
	i--;
    //i ontient maintenant le nombre de caractre
    return (((LCD_WIDTH_PX-(6*i+i-1))/2)+9);
}
